export class DefaultMap<K = string, V = string> {
	inner = new Map<K, V>();

	constructor(
		private def: () => V,
	) {}

	get(key: K) {
		if (!this.inner.has(key)) this.inner.set(key, this.def());
		return this.inner.get(key)!;
	}

	set(key: K, value: V) {
		this.inner.set(key, value);
	}

	[Symbol.iterator] = () => this.inner[Symbol.iterator]();
}
